#!/bin/sh
# $Id: t-pm-rsad-3.sh,v 1.7 2013/12/20 17:54:06 ca Exp $
#
# ----------------------------------------
# test pmilter RSAD
# uses smtpcnf.sh.
# ----------------------------------------
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

chkcto smtps MTA_USE_PMILTER '(--enable-pmilter)'
chkcto smtps MTA_USE_RSAD

PMPRG="-p ../libpmilter/t-pmilter-1"
PMOPT=""

if test X"`uname`" != "XOSF1"
then
while getopts O:p:s:V FLAG
do
  case "${FLAG}" in
    O) PMOPT="${PMOPT} ${OPTARG}";;
    p) PMPRG="-p ${OPTARG}";;
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || myexit 1
rm -f ${MTMAP}

${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4; }
smar { Log_Level = 12; nameserver = ${NS}; }
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }

smtps {
Log_Level = 19;
flags={prdr};
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
policy_milter { socket {type=unix; path="pmilter.sock";} timeout=2; }
}

EOF

# ----------------------------------------
# reject rcpt command in milter (deferred): 2*temp
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
# XREF: SMTP_R_D_EOM=353
if ${SHELL} ${SCRIPTS}/smtpcnf.sh ${PMPRG} ${PMOPT} -P "-r b=353" -Z 'smtpc2' -c '-E -9' -E 0 -A 0 -X 0 "$@" -S"a@b.c" -n 2 -R"d450@y.z -Rd452@y.z"
then
    ERR=false
else
    echo "$0: test ${TEST} failed"
    ERR=true
    test X"${MTA_STOPONERROR}" != X && myexit 1
fi

if ${GREP} 'RCPT=error, text=451 4.5.0 Temporary error' ${CLTL} >/dev/null
then
  if ${GREP} 'DOT=error, text=451 4.5.0 Temporary error' ${CLTL} >/dev/null
  then
    :
  else
    echo "$0: ${TEST}: missing DOT=error, text=451 4.5.0 Temporary error"
    ERR=true
  fi
else
  echo "$0: ${TEST}: missing RCPT=error, text=451 4.5.0 Temporary error"
  ERR=true
fi

if ${ERR}
then
    echo "$0: test ${TEST} check failed"
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && myexit 1
else
    ${VERBOSE} && echo "test ${TEST} succeeded"
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  myexit 1
fi
