#!/bin/sh
# $Id: t-reuse-1.sh,v 1.6 2013/11/23 19:59:43 ca Exp $
# Copyright (c) 2006 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test session reuse
# does not work (yet)
# uses smtpcnf.sh
# ----------------------------------------
#

# source directory of this (and other) shell script
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || exit 1

killit()
{
rm -f ${QMGRCONFMAP} ${MTMAP}
exit 1
}

# create restrictions
${CAT} > ${QMGRCONF} <<EOF
oci:127.0.0.1	1
ocm:127.0.0.1	1
octo:127.0.0.1	20
EOF
# create map
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}
rm -f ${MTMAP}
trap killit 2

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
rcpt.tld	[127.0.0.1]
sender.tld	[10.1.1.1]
EOF

# ----------------------------------------
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=1;
  flags = { reuse_connection };
  retry_delay_min = 30;
  retry_delay_max = 60;
}
smar { Log_Level = 9; nameserver = ${NS}; DNS_timeout = 5; }
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4;
  connect_only_to = 127.0.0.1;
  flags=timing;
}
smtps { Log_Level = 9;
  daemon_address = localhost:${SRVPORT};
  wait_for_server=4;
}
EOF

# ----------------------------------------
# 
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

# XREF: QMGR_TEST_SCHED_DLY
if ${SHELL} ${SD}/smtpcnf.sh -1 -E 16 -X '(1[0-6]|[1-9])' -A 16 -s 20 -Q '-t 0x200' -Y '-@ P -w -1' -Z smtpc2 -c '-Fsender.tld -Yrcpt.tld -T 2 -t 8 -m 16 -s 8'
then
  if ${GREP} 'Max busy threads  * 1' ${SRVL} >/dev/null
  then
    :
  else
    ${VERBOSE} && echo "${TEST}: Max busy threads wrong"
    ERR=true
  fi
  if ${GREP} '^Sessions reused *[1-9]' ${SCL} >/dev/null
  then
    :
  else
    ${VERBOSE} && echo "${TEST}: Sessions reused wrong"
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed"
  test X"${MTA_STOPONERROR}" != X && exit 1
else
  ${VERBOSE} && echo "test ${TEST} succeeded"
fi
fi

rm -f ${QMGRCONFMAP} f ${MTMAP}

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
