/*
 $Id: binsearch.h,v 1.2 2010/08/21 16:28:13 ca Exp $
 */

#ifndef SM_BINSEARCH_H
#define SM_BINSEARCH_H 1

#include "sm/generic.h"
#include "sm/error.h"

struct sm_identry_S
{
	const char *idt_id;
	/* what else? */
};

typedef struct sm_identry_S	sm_identry_T, *sm_identry_P;

struct sm_binlen_S
{
	int	bl_first;
	int	bl_last;
};

typedef struct sm_binlen_S	sm_binlen_T, *sm_binlen_P;

sm_ret_T sm_binsearch(sm_identry_P _idtab, int _sz, const char *_id, int *_pidx);

sm_ret_T sm_binleninit(sm_identry_P _idtab, uint _sz, sm_binlen_P _bltab, uint _blsz);
sm_ret_T sm_binlensrch(sm_identry_P _idtab, uint _sz, sm_binlen_P _bltab, uint _blsz, const char *_id, uint _idlen, int *_pidx);

#define SMBINSEARCH(pfx, idtab_T, ide)		\
sm_ret_T	\
pfx##_bsrch(idtab_T idtab, int sz, const char *id, int *pidx)	\
{	\
	int cmp, low, mid, high;	\
	\
	SM_REQUIRE(id != NULL);	\
	SM_REQUIRE(pidx != NULL);	\
	SM_REQUIRE(idtab != NULL);	\
	SM_REQUIRE(sz > 0);	\
	\
	low = 0;	\
	high = sz - 1;	\
	while (low <= high) {	\
		mid = (low + high) / 2;	\
		cmp = strcmp(id, idtab[mid].ide);	\
		if (cmp == 0) {	\
			*pidx = mid;	\
			return SM_SUCCESS;	\
		}	\
		else if (cmp < 0)	\
			high = mid - 1;	\
		else if (cmp > 0)	\
			low = mid + 1;	\
	}	\
	return sm_err_perm(SM_E_NOTFOUND);	\
}

#define SMBINSRCHN(pfx, idtab_T, ide, len)		\
sm_ret_T	\
pfx##_bsrchn(idtab_T idtab, int sz, const char *id, int len, int *pidx)	\
{	\
	int cmp, low, mid, high;	\
	\
	SM_REQUIRE(id != NULL);	\
	SM_REQUIRE(pidx != NULL);	\
	SM_REQUIRE(idtab != NULL);	\
	SM_REQUIRE(sz > 0);	\
	\
	low = 0;	\
	high = sz - 1;	\
	while (low <= high) {	\
		mid = (low + high) / 2;	\
		cmp = strncmp(id, idtab[mid].ide, len);	\
		if (cmp == 0)	\
			cmp = len - strlen(idtab[mid].idt_id);	\
		if (cmp == 0) {	\
			*pidx = mid;	\
			return SM_SUCCESS;	\
		}	\
		else if (cmp < 0)	\
			high = mid - 1;	\
		else if (cmp > 0)	\
			low = mid + 1;	\
	}	\
	return sm_err_perm(SM_E_NOTFOUND);	\
}

#endif /* SM_BINSEARCH_H */
