/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: err.h,v 1.4 2008/02/04 15:44:11 ca Exp $
 */

#ifndef SM_ERR_H
#define SM_ERR_H 1

#include "sm/generic.h"
#include "sm/varargs.h"
#if HAVE_ERR_H
#include <err.h>
#endif

#if !HAVE_ERR
void err(int _eval, const char *_fmt, ...);
void errx(int _eval, const char *_fmt, ...);
void verr(int _eval, const char *_fmt, va_list _ap);
void verrx(int _eval, const char *_fmt, va_list _ap);

void warn(const char *_fmt, ...);
void vwarn(const char *_fmt, va_list _ap);
#endif

#endif /* SM_ERR_H */
