#!/bin/sh
# $Id: t-wait-0.sh,v 1.5 2010/12/13 06:22:45 ca Exp $
# Copyright (c) 2004, 2010 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
#
test -s stop && exit 1

# program used in these tests
PRG=./t-wait-0
OUT=t-wait-0.out
# XREF: t-wait-0.c
PIDF=t-wait-0.pid
TEST=0
VERBOSE=false

while getopts V FLAG
do
  case "${FLAG}" in
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`

runandchk()
{
	$VERBOSE && set -x
	${PRG} "$@" >$OUT 2>&1 &
	PID=$!
	sleep 2
	i=0
	TEST=`expr $TEST + 1 `
	while [ $i -le 60 -a -s $PIDF ]
	do
		i=`expr $i + 1 `
		sleep 2
	done
	if [ -s $PIDF ]
	then
		echo "$0: $TEST failed: $PIDF still exists."
		ERR=1
		kill $PID
		sleep 2
		kill -9 $PID
		exit 1
	fi
}

runandchk -h 3 -b
runandchk -B -h 3 -b
runandchk -B -h 3 -w 5 -b

exit 0
