#!/bin/sh
# $Id: t-smar-mx-0.sh,v 1.6 2013/11/19 04:59:17 ca Exp $
#
# ------------------------------------------------------------
# Description:
# Script to test MX/AAAA expansion for RFC2821 addresses.
# Uses smar, t-smar.sh, DNS
# Note: this program relies on the meta1.org DNS server.
# ------------------------------------------------------------
#

if test X"${MTA_NO_DNS_TEST}" != "X"
then
  echo "SKIPPED: $0"
  exit 0
fi

TPRG=./t-smar-1

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../smar
fi
. ${SD}/common.sh
chkctoprg ${TPRG} MTA_NETINET6

OK=smar.ok
rm -f ${SOCK} ${PIDS}

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TEST=1
# ----------------------------------------
if echo "${SKIP} X" | grep -v " ${TEST} " > /dev/null
then
# temp.HACK: -6 for smar to use IPv6
MTA_SMAROPTS="${MTA_SMAROPTS} -o -6"
export MTA_SMAROPTS
A='<a1@ipv6-mx1.meta1.org>'
if ${SHELL} ${SD}/t-smar.sh -e 'IP\[0\]=fec0:0:0:0:2fd:87fe:1e72:1d4f' ${A}
then
  ${VERBOSE} && echo "$0: test ${TEST} OK"
else
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed: ${A}"
  test X"${MTA_STOPONERROR}" != X && exit ${ERRS}
fi
fi

test ${ERRS} -eq 0 && rm -f ${OUT} ${IP} ${OK}

exit ${ERRS}
