/*
 * Copyright (c) 2004-2006 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: smtpsh.h,v 1.17 2013/10/23 22:14:06 ca Exp $
 */

#ifndef SMTPSH_H
#define SMTPSH_H 1

#include "sm/generic.h"
#include "sm/common.h"
#include "sm/hdrmod.h"
#include "smtps-str.h"

/* size for SMTP communication buffers */
#define SMTPBUFSIZE	1024
#define SMTPMAXSIZE	4096
#define SMTPMSGIDSIZE	256

/* maximum number of arguments for commands */
#define SS_ARGS_MAX	8

sm_ret_T ss_hdl_session(ss_sess_P _sess, sm_ret_T _sessok);
sm_ret_T ss_sess_new(ss_ctx_P _ss_ctx, ss_sess_P *_pss_sess);
sm_ret_T ss_sess_free(ss_sess_P _ss_sess);

sm_ret_T ssm_mail_new(ss_ta_P _ss_ta, bool _alloc_pa, ss_mail_P *_pmail);
sm_ret_T ssm_mail_free(ss_ta_P _ss_ta, ss_mail_P _mail);
sm_ret_T ssr_rcpts_new(ss_ta_P _ss_ta, ss_rcpts_P _rcpts, ss_rcpt_P *_prcpt);
sm_ret_T ssr_rcpt_free(ss_ta_P _ss_ta, ss_rcpt_P _rcpt);
/* sm_ret_T ssr_rcpts_free(ss_ta_P _ss_ta, ss_rcpts_P _rcpts); */

sm_ret_T ssr_rcpt_add_mod(ss_sess_P _ss_sess, ushort _type, rcpt_idx_T rcpt_idx);

sm_ret_T ss_ta_clr(ss_ta_P _ss_ta);
sm_ret_T ss_ta_abort(ss_sess_P _ss_sess, ss_ta_P _ss_ta);
sm_ret_T ss_ta_init(ss_sess_P _ss_sess, ss_ta_P _ss_ta);

sm_ret_T ss_sess_conf(ss_sess_P _ss_sess);
#if MTA_USE_TLS
sm_ret_T ss_sess_tls(ss_sess_P _ss_sess, tls_cnf_P _tls_cnf);
#endif

sm_ret_T ss_cdb_set_grp(ss_sess_P _ss_sess, sm_file_T *_fp, sm_logcategory_P _category, sm_logmodule_P _module);

#endif /* SMTPSH_H */
